﻿using DotNetCore.CAP;
using MapsterMapper;
using MediatR;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Sharing.Province.Dtos;
using Sharing.Province.Dtos.HuiJu;
using Sharing.Province.Dtos.XieTong.Send;
using Sharing.WebCore;

namespace Sharing.Province.Controllers
{
    public class ProvinceController : BaseController
    {
        private readonly IChannelConfigurationManager _channelConfigurationManager;
        private readonly PusherProvider _pusherProvider;
        private readonly ICapPublisher _capPublisher;
        private readonly IMapper _mapper;
        private readonly IMediator _mediator;

        public ProvinceController(IChannelConfigurationManager channelConfigurationManager, PusherProvider pusherProvider, ICapPublisher capPublisher, IMapper mapper, IMediator mediator)
        {
            _channelConfigurationManager = channelConfigurationManager;
            _pusherProvider = pusherProvider;
            _capPublisher = capPublisher;
            _mapper = mapper;
            _mediator = mediator;
        }

        [HttpGet("test")]
        public async Task<string> Test()
        {
            var pusher = _pusherProvider.CreatePusher(_channelConfigurationManager);
            await pusher.PushOrderCreatedAsync(new SubmitCaseInfoRequest(), HttpContext.RequestAborted);
            var a = _channelConfigurationManager.GetConfigurationProvince().HuiJu;

            Reponse.Success();
            Reponse.Failed("");

            return a;
        }

        /// <summary>
        /// 测试推送
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        [HttpPost("getcaseresultreceive")]
        [AllowAnonymous]
        public async Task<string> GetCaseResultReceive([FromBody] GetCaseResultReceiveInfo dto)
        {
            //var data = _mapper.Map<GetCaseResultReceive>(dto);

            var pusher = _pusherProvider.CreatePusher(_channelConfigurationManager);

            //var dataReceive = _mapper.Map<GetCaseResultReceiveInfo>(data);
            var datarequest = new GetCaseResultReceiveData
            {
                GetCaseResultReceiveInfos = new List<GetCaseResultReceiveInfo>
                {
                    dto
                }
            };

            var request = new GetCaseResultReceiveRequest();
            request.SetData(datarequest);

            var response = await pusher.PushGetCaseResultReceiveAsync(request, cancellationToken: default);

            return response.Description;

            //将上报信息写入本地库
            // await _getCaseResultReceiveRepository.AddAsync(data);
            // await _mediator.Publish(new OrderCreatedNotification(new Orders.DataOrder()));
            //信息上报
            //await _mediator.Publish(new GetCaseResultReceiveNotification(data));
            // await _capPublisher.PublishAsync("GetCaseResultReceive", dto, cancellationToken: HttpContext.RequestAborted);
        }
    }
}
